#include "std.h"

const char graph_bar[]={
	0xFF,0xFF,0xE0,
	0x8D,0xB1,0xE0,
	0xB5,0xAD,0xE0,
	0x8D,0xAD,0xE0,
	0xB5,0xAD,0xE0,
	0xB5,0xAD,0xC0,
	0xB6,0x6D,0x80,
	0xFF,0xFF,0x0,
};

Files *files;

int SelectFile (char * file_name)
// -1 no file , 0 complate
{
	int key;
	char str[15];
	FONTCHARACTER find_path[50];
	int size;
	int top, buttom;
	int index, redraw;
	int i;

	CharToFont("\\\\fls0\\*",find_path);
	size = ReadFile( find_path );
	qsort( files, size, sizeof(Files), filecmp );

	if( size < 1 )   //no file
		return -1;

	index = 0;
	redraw = 1;
	top = 0;

/*				Main Loop			*/

	while(1)
	{
		if( redraw )
		{
			Bdisp_AllClr_VRAM();
			DrawPicture( 1, 56, 19, 8, IMB_WRITEMODIFY_NORMAL, IMB_WRITEKIND_OVER, graph_bar );
			locate(1, 1);
			Print("Program List");
			if( top > index )
				top = index;
			if( index > top + N_LINE - 1 )
				top = index - N_LINE + 1;
			if( top < 0 )
				top = 0;

			for(i = 0;i < N_LINE && i + top < size; ++i ){
				locate( 1, i + 2 );
				Printf( " %-12s:%6u ", files[i + top].filename, files[i + top].filesize );
			}
			locate( 1, (index - top) + 2 );
			PrintfRev( " %-12s:%6u ", files[index].filename, files[index].filesize );
			if( top > 0 )
				PrintXY( 120, 8, "\xE6\x92", top == index );
			if( top + N_LINE < size  )
				PrintXY( 120, N_LINE*8, "\xE6\x93" , top + N_LINE - 1 == index );

			redraw = 0;
		}
		GetKey(&key);
		if( key==KEY_CTRL_UP ){
			if( --index < 0 )
				index = size - 1;
			redraw = 1;
		}
		else if( key==KEY_CTRL_DOWN ){
			if( ++index > size - 1 )
				index = 0;
			redraw = 1;
		}
		else if( key==KEY_CTRL_EXE || key == KEY_CTRL_F1)
		{
			strcpy( file_name,strcat( (files[index].filename), ".mcl") );
			free(files);
			return 0;
		}
	}	
}

int ReadFile( FONTCHARACTER  *find_path )
{
	char str[20];
	FONTCHARACTER find_name[20];
	FILE_INFO file_info;
	int find_h;
	int size, i;

	size = 0;
/*				Get File Num			*/

	Bfile_FindFirst (find_path,&find_h,find_name,&file_info);
	if( /*file_info.type == DT_DIRECTORY ||*/ IsMclFile( find_name ) )		
		size++;
	while(Bfile_FindNext(find_h,find_name,&file_info)==0){
		if( /*file_info.type == DT_DIRECTORY ||*/ IsMclFile( find_name ) )
			size++;
	}
	Bfile_FindClose(find_h);
/*				Get Name & Size			*/
	i = 0;
	files = (Files *)malloc(size*FILENAMEMAX);
	Bfile_FindFirst (find_path,&find_h,find_name,&file_info);
	if( /*file_info.type == DT_DIRECTORY ||*/ IsMclFile( find_name ) ){
		FontToChar(find_name,str);
		strncpy( files[i].filename, str, strlen(str) - 4 );
		files[i].filesize = file_info.dsize;
		i++;
	}
	while(Bfile_FindNext(find_h,find_name,&file_info)==0)
	{
		if( /*file_info.type == DT_DIRECTORY ||*/ IsMclFile( find_name ) ){
			FontToChar(find_name,str);
			strncpy( files[i].filename, str, strlen(str) - 4 );
			files[i].filesize = file_info.dsize;
			i++;
		}
	}
	Bfile_FindClose(find_h);
	return size;
}

FONTCHARACTER * CharToFont(const char *cFileName,FONTCHARACTER *fFileName)
{
	int i,len = strlen(cFileName);
	for(i=0; i<len ;++i)
		fFileName[i] = cFileName[i];
	fFileName[i]=0;
	return fFileName;
}
char * FontToChar(const FONTCHARACTER *fFileName,char *cFileName)
{
	int i = 0;
	while((cFileName[i]=fFileName[i])!=0)++i;
	return cFileName;
}

int IsMclFile( FONTCHARACTER *find_name )
{
	char str[15];
	FontToChar(find_name,str);
	return (strcmp(str + strlen(str) - 4, ".mcl") == 0);
}

int filecmp( const void *p1, const void *p2 )
{
	return strcmp( ((Files *)p1)->filename, ((Files *)p2)->filename );
}