#include "Malical.h"
#include "std.h"
#include "MclStdlib.h"
#include "KeySH4.h"

const char *ARG_ERROR = "Arguments error";
const char *NUM_ERROR = "Wrong number of func parameter";
char * buf;

#define arg(i)		(arg_stk->stk[i])
#define value(i)	(arg_stk->stk[i]->value)

/////////////////////////////////
//     List of Math Lib
/////////////////////////////////

CFUNCTION CFunction[]=
{
	// value
	{"sin"		,	mcl_sin},
	{"cos"		,	mcl_cos},
	{"tan"		,	mcl_tan},
	{"atn"		,	mcl_atn},
	{"int"		,	mcl_int},
	{"abs"		,	mcl_abs},
	{"eval"		,	mcl_eval},
	{"rand"		,	mcl_rand},
	// str
	{"val"		,	mcl_val},
	{"tos"		,	mcl_tos},
	{"chr"		,	mcl_chr},
	{"asc"		,	mcl_asc},
	{"mid"		,	mcl_mid},
	{"len"		,	mcl_len},
	{"type"		,	mcl_type},
	{"upper"	,	mcl_upper},
	{"lower"	,	mcl_lower},
	// io
	{"print"	,	mcl_print},
	{"printrev"	,	mcl_printrev},
	{"printxy"	,	mcl_printxy},
	{"printmini",	mcl_printmini},
	{"printnum"	,	mcl_printnum},
	{"printnumxy",	mcl_printnumxy},
	{"printnummini",mcl_printnummini},
	{"gets"		,	mcl_gets},
	{"getkey"	,	mcl_getkey},
	{"iskeydown",	mcl_iskeydown},
	{"locate"	,	mcl_locate},
	// graph
	{"line"		,	mcl_line},
	{"box"		,	mcl_box},
	{"circle"	,	mcl_circle},
	{"allclr"	,	mcl_allclr},
	{"areaclr"	,	mcl_areaclr},
	{"lineclr"	,	mcl_lineclr},
	{"arearev"	,	mcl_arearev},
	{"setpoint"	,	mcl_setpoint},
	{"getpoint"	,	mcl_getpoint},
	{"savedisp"	,	mcl_savedisp},
	{"rcldisp"	,	mcl_rcldisp},
	{"rclpict"	,	mcl_rclpict},
	{"putdisp"	,	mcl_putdisp},
	{"popupwin"	,	mcl_popupwin},
	// array
	{"push"		,	mcl_push},
	{"delete"	,	mcl_delete},
	{"clear"	,	mcl_clear},
	{"sizeof"	,	mcl_sizeof},
	{"showap"	,	mcl_showap},
	// RTC
	{"rtcreset",	mcl_rtcreset},
	{"setyear",		mcl_setyear},
	{"setmonth",	mcl_setmonth},
	{"setdomonth",	mcl_setdomonth},
	{"setdoweek",	mcl_setdoweek},
	{"sethour",		mcl_sethour},
	{"setminute",	mcl_setminute},
	{"setsecond",	mcl_setsecond},
	{"readyear",	mcl_readyear},
	{"readmonth",	mcl_readmonth},
	{"readdomonth",	mcl_readdomonth},
	{"readdoweek",	mcl_readdoweek},
	{"readhour",	mcl_readhour},
	{"readminute",	mcl_readminute},
	{"readsecond",	mcl_readsecond},
	// ctrl
	{"exit"		,	mcl_exit},
	{"sleep"	,	mcl_sleep},
//	{"cpuspeed"	,	mcl_cpuspeed},
	{"waitkey"	,	mcl_waitkey},
};
const int CfuncSize = sizeof(CFunction)/sizeof(CFUNCTION);

/********           LIB           ********/
//////////////////////////////////
//          Value Lib
//////////////////////////////////
void mcl_sin(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_num(arg(0))) MalicalError(ARG_ERROR);
	n = sin(value(0).d);
	obj_create(objr,VT_NUM,&n);
}
void mcl_cos(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_num(arg(0))) MalicalError(ARG_ERROR);
	n = cos(value(0).d);
	obj_create(objr,VT_NUM,&n);
}
void mcl_tan(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_num(arg(0))) MalicalError(ARG_ERROR);
	n = tan(value(0).d);
	obj_create(objr,VT_NUM,&n);
}
void mcl_atn(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_num(arg(0))) MalicalError(ARG_ERROR);
	n = atan(value(0).d);
	obj_create(objr,VT_NUM,&n);
}
void mcl_int(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_num(arg(0))) MalicalError(ARG_ERROR);
	n = (int)(value(0).d);
	obj_create(objr,VT_NUM,&n);
}
void mcl_abs(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_num(arg(0))) MalicalError(ARG_ERROR);
	n = fabs(value(0).d);
	obj_create(objr,VT_NUM,&n);
}
void mcl_eval(ObjectStack *arg_stk,Object *objr)
{
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_str(arg(0))) MalicalError(ARG_ERROR);
	EvalExpr(value(0).str,objr);
}
void mcl_rand(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=0) MalicalError(NUM_ERROR);
	n = rand();
	obj_create(objr,VT_NUM,&n);
}

//////////////////////////////////
//        String Lib
//////////////////////////////////
void mcl_val(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_str(arg(0))) MalicalError(ARG_ERROR);
	n = atof(value(0).str);
	obj_create(objr,VT_NUM,&n);
}
void mcl_tos(ObjectStack *arg_stk,Object *objr)
{
	char buf[STRING_BUFFER_SIZE];
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	obj_to_str(arg_stk->stk[0],buf);
	obj_create(objr,VT_STR,buf);
}
void mcl_chr(ObjectStack *arg_stk,Object *objr)
{
	char ch[]=" ";
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_num(arg(0))) MalicalError(ARG_ERROR);
	ch[0] = (char)value(0).d;
	obj_create(objr,VT_STR,ch);
}
void mcl_asc(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_str(arg(0))) MalicalError(ARG_ERROR);
	n = (char)value(0).str[0];
	obj_create(objr,VT_NUM,&n);
}
void str_mid(char *d,const char *s,int begin,int length)
{
	int i;
	for (i=0;i<length;++i)
	{
		d[i] = s[begin+i];
	}
	d[i] = '\0';
}
void mcl_mid(ObjectStack *arg_stk,Object *objr)
{
	char buf[STRING_BUFFER_SIZE];
	if (arg_stk->size!=3) MalicalError(NUM_ERROR);
	if (! o_is_str(arg(0))) MalicalError(ARG_ERROR);
	str_mid(buf,		value(0).str,
				(int)	value(1).d,
				(int)	value(2).d);
	obj_create(objr,VT_STR,buf);
}
void mcl_len(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_str(arg(0))) MalicalError(ARG_ERROR);
	n = strlen(value(0).str);
	obj_create(objr,VT_NUM,&n);
}
void mcl_upper(ObjectStack *arg_stk,Object *objr)
{
	char *p;
	int len = strlen(value(0).str);
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_str(arg(0))) MalicalError(ARG_ERROR);
	buf = (char *)malloc(len + 1);
	p = value(0).str;
	while( *p ){
		*buf = toupper( *p );
		buf++;p++;
	}
	*buf = '\0';
	obj_create(objr,VT_STR,buf - len);
}
void mcl_lower(ObjectStack *arg_stk,Object *objr)
{
	char *p;
	int len = strlen(value(0).str);
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_str(arg(0))) MalicalError(ARG_ERROR);
	buf = (char *)malloc(len + 1);
	p = value(0).str;
	while( *p ){
		*buf = tolower( *p );
		buf++;p++;
	}
	*buf = '\0';
	obj_create(objr,VT_STR,buf - len);
}
void mcl_type(ObjectStack *arg_stk,Object *objr)
{
	char buf[20];
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	strcpy(buf,TYPE_TEXT[arg_stk->stk[0]->tag]);
	obj_create(objr,VT_STR,buf);
}
//////////////////////////////////
//           IO Lib
//////////////////////////////////
void mcl_print(ObjectStack *arg_stk,Object *objr)
{
	char buf[STRING_BUFFER_SIZE];
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	obj_to_str(arg(0),buf);
	Printf(buf);
	obj_create(objr,VT_NIL,0);
}
void mcl_printrev(ObjectStack *arg_stk,Object *objr)
{
	char buf[STRING_BUFFER_SIZE];
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	obj_to_str(arg(0),buf);
	PrintfRev(buf);
	obj_create(objr,VT_NIL,0);
}
void mcl_printxy(ObjectStack *arg_stk,Object *objr)
{
	char buf[STRING_BUFFER_SIZE];
	if (arg_stk->size!=4) MalicalError(NUM_ERROR);
	if (!o_is_num(arg(0)) || !o_is_num(arg(1)) ||
		!o_is_num(arg(3)))MalicalError(ARG_ERROR);
	obj_to_str(arg(2),buf);
	PrintfXY (	value(0).d,
				value(1).d,
				value(3).d,
				buf);
	obj_create(objr,VT_NIL,0);
}
void mcl_printmini(ObjectStack *arg_stk,Object *objr)
{
	char buf[STRING_BUFFER_SIZE];
	if (arg_stk->size!=4) MalicalError(NUM_ERROR);
	if (!o_is_num(arg(0)) || !o_is_num(arg(1)) ||
		!o_is_num(arg(3)) )MalicalError(ARG_ERROR);
	obj_to_str(arg(2),buf);
	PrintfMini (value(0).d,
				value(1).d,
				value(3).d + MINI_OVER,
				buf);
	obj_create(objr,VT_NIL,0);
}
void mcl_printnum(ObjectStack *arg_stk,Object *objr)
{
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_num(arg(0))) MalicalError(ARG_ERROR);
	PrintNum(value(0).d);
	obj_create(objr,VT_NIL,0);
}
void mcl_printnumxy(ObjectStack *arg_stk,Object *objr)
{
	int i;
	if (arg_stk->size!=4) MalicalError(NUM_ERROR);
	for (i=0;i<4;++i) if (!o_is_num(arg(i))) MalicalError(ARG_ERROR);
	PrintNumXY(value(0).d,value(1).d,value(3).d,value(2).d);
	obj_create(objr,VT_NIL,0);
}
void mcl_printnummini(ObjectStack *arg_stk,Object *objr)
{
	int i;
	if (arg_stk->size!=4) MalicalError(NUM_ERROR);
	for (i=0;i<4;++i) if (!o_is_num(arg(i))) MalicalError(ARG_ERROR);
	PrintNumMini(value(0).d,value(1).d,value(3).d,value(2).d);
	obj_create(objr,VT_NIL,0);
}
void mcl_gets(ObjectStack *arg_stk,Object *objr)
{
	char buf[STRING_BUFFER_SIZE];
	if (arg_stk->size!=2) MalicalError(NUM_ERROR);
	if (! o_is_num(arg(0)) || ! o_is_num(arg(1)) ) MalicalError(ARG_ERROR);
	*buf = 0;
	InputString(value(0).d,value(1).d,buf,21);
	obj_create(objr,VT_STR,buf);
}
void mcl_getkey(ObjectStack *arg_stk,Object *objr)
{
	unsigned int key;
	double n;
	if (arg_stk->size!=0) MalicalError(NUM_ERROR);
	GetKey (&key);
	n = key;
	obj_create(objr,VT_NUM,&n);
}
void mcl_iskeydown(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_num(arg(0))) MalicalError(ARG_ERROR);
	n = IsKeyDownSH4( value(0).d );
	obj_create(objr,VT_NUM,&n);
}
void mcl_locate(ObjectStack *arg_stk,Object *objr)
{
	if (arg_stk->size!=2) MalicalError(NUM_ERROR);
	if (!o_is_num(arg(0)) || !o_is_num(arg(1))) MalicalError(ARG_ERROR);
	locate(value(0).d,value(1).d);
	obj_create(objr,VT_NIL,0);
}
//////////////////////////////////
//           Graph Lib
//////////////////////////////////
void mcl_line(ObjectStack *arg_stk,Object *objr)
{
	int i;
	if (arg_stk->size!=4) MalicalError(NUM_ERROR);
	for (i=0;i<4;++i) if (!o_is_num(arg(i))) MalicalError(ARG_ERROR);
	Bdisp_DrawLineVRAM(value(0).d,value(1).d,value(2).d,value(3).d);
	obj_create(objr,VT_NIL,0);
}
void mcl_box(ObjectStack *arg_stk,Object *objr)
{
	int i;
	if (arg_stk->size!=4) MalicalError(NUM_ERROR);
	for (i=0;i<4;++i) if (!o_is_num(arg(i))) MalicalError(ARG_ERROR);
	Bdisp_DrawLineVRAM (value(0).d,value(1).d,value(2).d,value(1).d);
	Bdisp_DrawLineVRAM (value(0).d,value(3).d,value(2).d,value(3).d);
	Bdisp_DrawLineVRAM (value(0).d,value(1).d,value(0).d,value(3).d);
	Bdisp_DrawLineVRAM (value(2).d,value(1).d,value(2).d,value(3).d);
	obj_create(objr,VT_NIL,0);
}
void mcl_circle(ObjectStack *arg_stk,Object *objr)
{
	int i;
	if (arg_stk->size!=3) MalicalError(NUM_ERROR);
	for (i=0;i<3;++i) if (!o_is_num(arg(i))) MalicalError(ARG_ERROR);
	DrawCircle( value(0).d, value(1).d, value(2).d );
	obj_create(objr,VT_NIL,0);
}
void mcl_allclr(ObjectStack *arg_stk,Object *objr)
{
	if (arg_stk->size!=0) MalicalError(NUM_ERROR);
	Bdisp_AllClr_VRAM();
	obj_create(objr,VT_NIL,0);
}
void mcl_areaclr(ObjectStack *arg_stk,Object *objr)
{
	int i;
	DISPBOX box;
	if (arg_stk->size!=4) MalicalError(NUM_ERROR);
	for (i=0;i<4;++i) if (!o_is_num(arg(i))) MalicalError(ARG_ERROR);
	box.left = value(0).d;box.top = value(1).d;box.right = value(2).d;box.bottom = value(3).d;
	Bdisp_AreaClr_VRAM (&box);
	obj_create(objr,VT_NIL,0);
}
void mcl_lineclr(ObjectStack *arg_stk,Object *objr)
{
	int i;
	if (arg_stk->size!=4) MalicalError(NUM_ERROR);
	for (i=0;i<4;++i) if (!o_is_num(arg(i))) MalicalError(ARG_ERROR);
	Bdisp_ClearLineVRAM( value(0).d,value(1).d,value(2).d,value(3).d );
	obj_create(objr,VT_NIL,0);
}
void mcl_arearev(ObjectStack *arg_stk,Object *objr)
{
	int i;
	if (arg_stk->size!=4) MalicalError(NUM_ERROR);
	for (i=0;i<4;++i) if (!o_is_num(arg(i))) MalicalError(ARG_ERROR);
	Bdisp_AreaReverseVRAM( value(0).d,value(1).d,value(2).d,value(3).d );
	obj_create(objr,VT_NIL,0);
}
void mcl_setpoint(ObjectStack *arg_stk,Object *objr)
{
	int i;
	if (arg_stk->size!=3) MalicalError(NUM_ERROR);
	for (i=0;i<3;++i) if (!o_is_num(arg(i))) MalicalError(ARG_ERROR);
	Bdisp_SetPoint_VRAM( value(0).d,value(1).d,value(2).d );
	obj_create(objr,VT_NIL,0);
}
void mcl_getpoint(ObjectStack *arg_stk,Object *objr)
{
	int i;
	if (arg_stk->size!=2) MalicalError(NUM_ERROR);
	for (i=0;i<2;++i) if (!o_is_num(arg(i))) MalicalError(ARG_ERROR);
	i = Bdisp_GetPoint_VRAM( value(0).d,value(1).d );
	obj_create(objr,VT_NUM,&i);
}
void mcl_putdisp(ObjectStack *arg_stk,Object *objr)
{
	int i;
	if (arg_stk->size!=0) MalicalError(NUM_ERROR);
	Bdisp_PutDisp_DD();
	obj_create(objr,VT_NIL,0);
}
void mcl_popupwin(ObjectStack *arg_stk,Object *objr)
{
    int i;
    if (arg_stk->size!=1) MalicalError(NUM_ERROR);
    if (!o_is_num(arg(0))) MalicalError(ARG_ERROR);
    PopUpWin(value(0).d);
    obj_create(objr,VT_NIL,0);
}

unsigned char *DispData[DISP_DATA_MAX];

void mcl_savedisp(ObjectStack *arg_stk,Object *objr)
{
	int n;

    if (arg_stk->size!=1) MalicalError(NUM_ERROR);
    if (!o_is_num(arg(0))) MalicalError(ARG_ERROR);
	n = (int)value(0).d;
	switch( n ){
		case 0: SaveDisp(SAVEDISP_PAGE1); 			break;
		case 1: SaveDisp(SAVEDISP_PAGE2);			break;
		case 2: SaveDisp(SAVEDISP_PAGE3);			break;
		case 3: case 4:	case 5:	case 6:	case 7:	case 8:	case 9:
		{
			n -= 3;
			if( DispData[n] == 0 )
				DispData[n] = (unsigned char*)malloc( IM_VRAM_SIZE );
			if( DispData[n] == 0 )
				MalicalError( "No enough mem" );

			Bdisp_GetDisp_VRAM( DispData[n] );	
			break;
		}
		default : MalicalError(ARG_ERROR); 			break;
	}
    obj_create(objr,VT_NIL,0);
}

void mcl_rcldisp(ObjectStack *arg_stk,Object *objr)
{
	int n;

    if (arg_stk->size!=1) MalicalError(NUM_ERROR);
    if (!o_is_num(arg(0))) MalicalError(ARG_ERROR);
	n = (int)value(0).d;
	switch( n ){
		case 0: RestoreDisp(SAVEDISP_PAGE1); 	break;
		case 1: RestoreDisp(SAVEDISP_PAGE2);	break;
		case 2: RestoreDisp(SAVEDISP_PAGE3);	break;
		case 3: case 4:	case 5:	case 6:	case 7:	case 8:	case 9:
		{
			n -= 3;
			if( DispData[n] != 0 )
				DrawPicture( 0,0, 128,64, IMB_WRITEMODIFY_NORMAL,IMB_WRITEKIND_OVER,DispData[n] );
			break;
		}
		default : MalicalError(ARG_ERROR); break;
	}
    obj_create(objr,VT_NIL,0);
}

void mcl_rclpict(ObjectStack *arg_stk,Object *objr)
{
	char pict_data[IM_VRAM_SIZE];
    FONTCHARACTER pict_name[30];
	char str[30];
	int handle;

    if (arg_stk->size!=1) MalicalError(NUM_ERROR);
    if (!o_is_str(arg(0))) MalicalError(ARG_ERROR);

	sprintf( str, "\\\\fls0\\%s", value(0).str );
	CharToFont( str, pict_name );
    handle = Bfile_OpenFile(pict_name,_OPENMODE_READ_SHARE);

	if( handle < 0 )
		MalicalError("No Picture");
	 
	if( Bfile_ReadFile( handle, pict_data, IM_VRAM_SIZE, 0x4C ) < IM_VRAM_SIZE )
		MalicalError("Picture read error");

	DrawPicture( 0,0, 128,64, IMB_WRITEMODIFY_NORMAL,IMB_WRITEKIND_OVER,pict_data );

    obj_create(objr,VT_NIL,0);
}
//////////////////////////////////
//           Array Lib
//////////////////////////////////
void mcl_push(ObjectStack *arg_stk,Object *objr)
{
	if (arg_stk->size!=2) MalicalError(NUM_ERROR);
	if (!o_is_arr(arg(0))) MalicalError(ARG_ERROR);
	array_push_back ((Array*)(value(0).ref),arg(1));
	obj_copy(objr,&arg(1));
}
void mcl_delete(ObjectStack *arg_stk,Object *objr)
{
	int i;
	if (arg_stk->size!=2) MalicalError(NUM_ERROR);
	if (!o_is_arr(arg(0)) || o_is_num(arg(1))) MalicalError(ARG_ERROR);
	i = value(1).d;
	array_delete ((Array*)(value(0).ref),i);
	obj_create(objr,VT_NIL,0);
}
void mcl_clear(ObjectStack *arg_stk,Object *objr)
{
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (!o_is_arr(arg(0))) MalicalError(ARG_ERROR);
	array_destory ((Array*)(value(0).ref));
	obj_create(objr,VT_NIL,0);
}
void mcl_sizeof(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (!o_is_arr(arg(0))) MalicalError(ARG_ERROR);
	n = ((Array*)(value(0).ref))->size;
	obj_create(objr,VT_NUM,&n);
}
void mcl_showap(ObjectStack *arg_stk,Object *objr)
{
	int i, j, maxi, maxj, sel;
	Array *arr;
	if (arg_stk->size!=5) MalicalError(NUM_ERROR);
	for (i=0;i<4;++i) if (!o_is_num(arg(i))) MalicalError(ARG_ERROR);
	if (!o_is_arr(arg(4)))  MalicalError(ARG_ERROR);

	arr = value(4).ref;
	if( value(2).d * value(3).d != arr->size ) MalicalError(ARG_ERROR);

	for( i = 0; i < value(3).d; i++ ){
		for( j = 0; j < value(2).d; j++ ){
			sel = array_element( arr, i * value(2).d + j)->obj.value.d;
			Bdisp_SetPoint_DDVRAM( j + value(0).d, i + value(1).d, sel );
		}
	}

	obj_create(objr,VT_NIL,0);
}

//////////////////////////////////
//           RTC Lib
//////////////////////////////////
void mcl_rtcreset(ObjectStack *arg_stk,Object *objr)
{
	if (arg_stk->size!=0) MalicalError(NUM_ERROR);
	RTCReset();
	obj_create(objr,VT_NIL,0);
}
void mcl_setyear(ObjectStack *arg_stk,Object *objr)
{
	int i;
	if (arg_stk->size!=4) MalicalError(NUM_ERROR);
	for (i=0;i<4;++i) if (!o_is_num(arg(i))) MalicalError(ARG_ERROR);
	RTCSetYear (	value(0).d,value(1).d,
					value(2).d,value(3).d);
	obj_create(objr,VT_NIL,0);
}
void mcl_setmonth(ObjectStack *arg_stk,Object *objr)
{
	if (arg_stk->size!=2) MalicalError(NUM_ERROR);
	if (!o_is_num(arg(0)) || !o_is_num(arg(1)) ) MalicalError(ARG_ERROR);
	RTCSetMonth (	value(0).d,value(1).d  );
	obj_create(objr,VT_NIL,0);
}
void mcl_setdomonth(ObjectStack *arg_stk,Object *objr)
{
	if (arg_stk->size!=2) MalicalError(NUM_ERROR);
	if (!o_is_num(arg(0)) || !o_is_num(arg(1)) ) MalicalError(ARG_ERROR);
	RTCSetDayOfMonth (	value(0).d,value(1).d  );
	obj_create(objr,VT_NIL,0);
}
void mcl_setdoweek(ObjectStack *arg_stk,Object *objr)
{
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (!o_is_num(arg(0))) MalicalError(ARG_ERROR);
	RTCSetDayOfWeek (	value(0).d   );
	obj_create(objr,VT_NIL,0);
}
void mcl_sethour(ObjectStack *arg_stk,Object *objr)
{
	if (arg_stk->size!=2) MalicalError(NUM_ERROR);
	if (!o_is_num(arg(0)) || !o_is_num(arg(1)) ) MalicalError(ARG_ERROR);
	RTCSetHour (	value(0).d,value(1).d  );
	obj_create(objr,VT_NIL,0);
}
void mcl_setminute(ObjectStack *arg_stk,Object *objr)
{
	if (arg_stk->size!=2) MalicalError(NUM_ERROR);
	if (!o_is_num(arg(0)) || !o_is_num(arg(1)) ) MalicalError(ARG_ERROR);
	RTCSetMinute (	value(0).d,value(1).d  );
	obj_create(objr,VT_NIL,0);
}
void mcl_setsecond(ObjectStack *arg_stk,Object *objr)
{
	if (arg_stk->size!=2) MalicalError(NUM_ERROR);
	if (!o_is_num(arg(0)) || !o_is_num(arg(1)) ) MalicalError(ARG_ERROR);
	RTCSetSecond (	value(0).d,value(1).d  );
	obj_create(objr,VT_NIL,0);
}

void mcl_readyear(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=0) MalicalError(NUM_ERROR);
	n = RTCReadYear();
	obj_create(objr,VT_NUM,&n);
}
void mcl_readmonth(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=0) MalicalError(NUM_ERROR);
	n = RTCReadMonth();
	obj_create(objr,VT_NUM,&n);
}
void mcl_readdomonth(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=0) MalicalError(NUM_ERROR);
	n = RTCReadDayOfMonth();
	obj_create(objr,VT_NUM,&n);
}
void mcl_readdoweek(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=0) MalicalError(NUM_ERROR);
	n = RTCReadDayOfWeek();
	obj_create(objr,VT_NUM,&n);
}
void mcl_readhour(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=0) MalicalError(NUM_ERROR);
	n = RTCReadHour();
	obj_create(objr,VT_NUM,&n);
}
void mcl_readminute(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=0) MalicalError(NUM_ERROR);
	n = RTCReadMinute();
	obj_create(objr,VT_NUM,&n);
}
void mcl_readsecond(ObjectStack *arg_stk,Object *objr)
{
	double n;
	if (arg_stk->size!=0) MalicalError(NUM_ERROR);
	n = RTCReadSecond();
	obj_create(objr,VT_NUM,&n);
}
//////////////////////////////////
//           Ctrl Lib
//////////////////////////////////
/*void mcl_cpuspeed(ObjectStack *arg_stk,Object *objr)
{
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_num(arg(0))) MalicalError(ARG_ERROR);
	switch( (int)value(0).d ){
		case 0: Reset_Calc(); 		break;
		case 1: CPUSpeedNormal(); 	break;
		case 2: CPUSpeedDouble(); 	break;
		case 3: CPUSpeedTriple();	break;
		case 4: CPUSpeedQuadruple();break;
		default : MalicalError(ARG_ERROR); break;
	}
	obj_create(objr,VT_NIL,0);
}*/
void mcl_sleep(ObjectStack *arg_stk,Object *objr)
{
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_num(arg(0))) MalicalError(ARG_ERROR);
	Sleep( value(0).d );
	obj_create(objr,VT_NIL,0);
}
void mcl_exit(ObjectStack *arg_stk,Object *objr)
{
	int i;

	ac_break = 0;
	free(prog);
	strcpy( token, "" );
	strcpy( line, "" );

	for( i = 0; i < FunctionSize; ++i ){
		if( Function[i] != 0 )
			free( Function[i] );
	}
	for( i = 0; i < DISP_DATA_MAX; ++i ){
		if( DispData[i] != 0 )
			free( DispData[i] );
	}

	if( arg_stk != 0 )
		delete_local_var_stack();
	var_stk_clear( &GlobalVar );

	exit(0);
}
void mcl_waitkey(ObjectStack *arg_stk,Object *objr)
{
	unsigned int key;
	if (arg_stk->size!=1) MalicalError(NUM_ERROR);
	if (! o_is_num(arg(0))) MalicalError(ARG_ERROR);
	while( key != value(0).d )
		GetKey( &key );
	obj_create(objr,VT_NIL,0);
}
/********           END           ********/

int funcmp( const void *p1, const void *p2 )
{
	return strcmp( ((CFUNCTION *)p1)->name, ((CFUNCTION *)p2)->name );
}
